/**
 ** joystickMainCodels.c
 **
 ** Codels called by execution task joystickMain
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <portLib.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "joystick.h"
#include "server/joystickHeader.h"

#define PERRMSG(fmt, args...) fprintf(stderr, "%s(): "fmt, __func__, ## args)

# define JOYSTICK_DEVICE_PATH "/dev/input/js0"

int joyresult;

/*------------------------------------------------------------------------
 *
 * joystickMainEnd  --  Termination codel
 *
 * Description: 
 * 
 * Returns:    OK or ERROR
 */

STATUS
joystickMainEnd(void)
{
  return OK;
}

/*------------------------------------------------------------------------
 *
 * joystickMainPerm  --  1st codel of permanent activity (called BEFORE other activities)
 *
 * Description: 
 * 
 * Reports:      OK
 *              S_joystick_ERROR_JOYSTICK
 * 
 * Returns:    OK or ERROR
 */

STATUS
joystickMainPerm(int *report)
{
  if (SDI_F->initIsDone == 0) {
    return OK;
  }

  joyresult = joystickPoll(&(SDI_F->joystick));
  if(0 > joyresult){
    PERRMSG("joystickPoll() returned %d\n", joyresult);
    *report = S_joystick_ERROR_JOYSTICK;
  }
  return OK;
}
/*------------------------------------------------------------------------
 * Init
 *
 * Description: 
 *
 * Reports:      OK
 *              S_joystick_ERROR_JOYSTICK_INIT
 */

/* xarmInitMain  -  codel EXEC of Init
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
xarmInitMain(int *report)
{
  if(joystickInit(JOYSTICK_DEVICE_PATH, &(SDI_F->joystick))!=OK) {
    SDI_F->initIsDone = 0;
    PERRMSG("joystickInit(%s) failed: %s\n", JOYSTICK_DEVICE_PATH, strerror(errno));
    *report = S_joystick_ERROR_JOYSTICK_INIT;
    return ETHER;
    
  }
  SDI_F->initIsDone = 1;
  return ETHER;
}


